<template>
    <div class="page-container">
        <div class="video-button-container">
            <VideoButton :source="'https://carti.crisp.help/en/article/enable-email-browse-abandonment-1ab3d4f/reader/?1608646549823'" />
        </div>
        <ValidationObserver
            ref="obs"
        >
            <div class="edit__top">
                <Tabs
                    :items="tabs"
                    @switch="tabIndex = $event"
                />
                <div class="edit__actions">
                    <ToggleButton
                        v-if="data"
                        v-model="data.status"
                        :font-size="12"
                        class="toggle-btn"
                        :height="24"
                        :labels="true"
                        color="rgb(45, 119, 245)"
                        @change="saveReminder"
                    />
                    <Buttons
                        :items="btns"
                        @openPreviewPopup="openPreviewPopup"
                        @saveReminder="saveReminder"
                    />
                </div>
            </div>
            <div class="row">
                <component
                    :is="activeTab"
                    class="col-12 col-xl-6"
                    :text-editor="data"
                    :data="data"
                    :picker-keys="pickerKeys"
                    @checkChanged="checkChanged"
                />
                <div class="col-12 col-xl-6 edit__preview">
                    <BrowseEmailExample
                        :data="data"
                    />
                </div>
            </div>
        </ValidationObserver>
        <SendTest
            v-if="previewPopup"
            ref="test"
            :input="{placeholder: 'E-mail Address', type: 'data',}"
            :show-text="showAlertText"
            @send="sendPreview"
            @close="previewPopup = false"
        >
            <template #unsaved>
                You have unsaved changes. We will send the last saved version of the message.
            </template>
        </SendTest>
    </div>
</template>

<script>
import BrowseTextEditor from "@/components/email/browse-abandonment/BrowseTextEditor";
import BrowseDesignEditor from "@/components/email/browse-abandonment/BrowseDesignEditor";
import BrowseSanding from "@/components/email/browse-abandonment/BrowseSanding";
import BrowseEmailExample from "@/components/email/browse-abandonment/BrowseEmailExample";
import browseReminder from "@/mixins/email/browse-abandonment.service";
import VideoButton from "@/components/header/VideoButton";
import {tags} from "@/mixins/add-tags"
import SendTest from "@/components/modals/SendTest";
import Tabs from "@/components/elements/Tabs"
import shop from '@/mixins/shop.service';

export default {
    name: "BrowseTableEdit",
    components: {VideoButton, BrowseEmailExample, BrowseSanding, BrowseDesignEditor, BrowseTextEditor, SendTest, Tabs},
    mixins: [browseReminder, tags, shop],
    data: () => ({
        emailPreview: '',
        data: null,
        edited: null,
        oldData: null,
        tabIndex: 0,
        tabs: [
            {title: 'Text editor', component: 'browse-text-editor'},
            {title: 'Design editor', component: 'browse-design-editor'},
            {title: 'Sending', component: 'browse-sanding'}
        ],
        btns: [
            {title: 'Send Test', event: 'openPreviewPopup', class: 'light-blue-btn'},
            {title: 'Save', event: 'saveReminder', class: 'blue-btn'}
        ],
        pickerKeys: {
            body_text: false,
            button_color: false,
            button_text: false,
            header_background: false,
            header_text: false,
            link: false,
            title: false,
        },
        previewPopup: false,
        showAlertText: false,
        showModalAddEmailCredits: false,
        oldDesing: null,
        // design: {
        //     body_text: "#03183B",
        //     button_color: "#2d77f5",
        //     button_text: "#ffffff",
        //     header_background: "#EFF4FE",
        //     header_text: "#03183B",
        //     link: "#2d77f5",
        //     title: "#03183B",
        // },
    }),
    computed: {
        activeTab() {
            return this.tabs[this.tabIndex].component
        }
    },
    created() {
        this.getItems()
    },
    methods: {
        getItems() {
            this.getById(this.$route.params.id).then(response => {
                const { data } = response
                const defaultTextBody = '#03183B'
                if(!data.colors.body_text) data.colors.body_text = defaultTextBody
                this.data = data
                this.oldData = JSON.parse(JSON.stringify(this.data))
                this.edited = this.createEditedObj(this.oldData)
                if(this.showAlertText) this.showAlertText = false
            }).catch(error => {
                console.log(error)
            });
        },
        openPreviewPopup() {
            if(!this.previewPopup) this.showAlertText = this.checkEditedItems(this.edited)
            this.previewPopup = !this.previewPopup
        },
        checkChanged(key) {
            const data = this.trackСhange(this.oldData, this.data, key)

            if(data.key) this.edited[data.key] = data.value
        },
        async saveReminder() {
            const result = await this.$refs.obs.validate();
            let valid = await this.$refs.obs
            if (result) {
                await  this.save(this.$route.params.id, this.data)
                    this.$notify({
                        type: 'success',
                        title: 'Saved'
                    });
                this.getItems()
                setTimeout(() => {
                    this.$refs.obs.reset()
                }, 2000)
              //     await this.$router.push('/email/browse-abandonment')
            } else this.getFormErrors(valid.errors)
        },
        /**
         *
         * @returns {Promise<void>}
         */
        async sendPreview(email) {
            try {
                await this.sendPreviewEmail(this.$route.params.id, {
                    email,
                })
                this.previewPopup = false
                this.$notify({
                    type: 'success',
                    title: 'Sent'
                })
            } catch (er){
                console.log(er)
                this.$refs.test.stopLoading()
            }
        },
    }
}
</script>

<style scoped lang="scss">

.popup-body-container {
    display: flex;
    justify-content: center;
    align-items: center;
}

.send-action {
    &-container {
        display: flex;
        flex-direction: column;
        width: 100%;
    }
    &__actions {
        margin-top: 1rem;
        display: flex;
        justify-content: flex-end;
        span {
            width: calc(100% - 145px);
            display: block;
            margin-right: auto;opacity: 0.8;
        }
    }

    .blue-btn {
        margin-left: 5px;
        padding: 0pc 20px;
    }
}


.btn {
    margin-right: 4px;
}

</style>
